/*
PROB:groups
ID: Nikolay Hunanov
*/

#include <iostream>
#include <cstdio>

using namespace std;

int n,p;
int dp[2][801][801];
// ---------------- index tree -----------
int idt[2][801][801];

void add(int row,int col,int pos,int val)
{
 for(;pos<=n;pos+=pos&(-pos))
    idt[row][col][pos]+=val;    
}

int srch(int row,int col,int pos)
{
 int res=0;
 for(;pos;pos-=pos&(-pos))
    res+=idt[row][col][pos];
 return res;   
}
// --------------- end index tree --------

int main()
{int i,j,k;

 scanf("%d %d",&n,&p);
 
 for(int i=1;i<=n;i++)
    { dp[1][i][i]=1; add(1,i,i,1); } 
    
 bool prev=1, next=0;
 
 for(i=2;i<=p;i++)
   {
    memset(idt[next],0,sizeof(idt[next]));
    for(j=i;j<=n;j++)
        for(k=1;k<=(j-(i-1));k++)
          {
           dp[next][j][k]=srch(prev,j-k,k);
           add(next,j,k,dp[next][j][k]);
          }
    prev=!prev; next=!next;
   } 
   
 int res=0;
 res=srch(prev,n,n);
 cout<<res<<endl;

 return 0;
}
// ****** ograni4eniqta :S 
