#include <cstdio>
#include <iostream>

typedef std :: string string;

const int MAX_N = 800 + 5;

int N, K;
unsigned long long dp[MAX_N][MAX_N];
int main()
{
    scanf("%d %d", &N, &K);
    dp[0][0] = 1;
    for(int size = 1; size <= N; size ++)
    	for(int groups = 0; groups + 1 <= K && size + groups <= N; groups ++)
    		for(int cnt = groups; cnt + size <= N; cnt ++)
    			dp[cnt + size][groups + 1] += dp[cnt][groups];
    std :: cout << dp[N][K] << "\n";
    return 0;
}
