#include <iostream>
#include <string>
using namespace std;

typedef unsigned long long LL;

const int MAX_N = 1024;
const int MAX_K = 1024;

int N, K;
LL dp[MAX_N][MAX_K];

int main()
{
	memset(dp, 0, sizeof(dp));
	
	cin >> N >> K;
	
	for(int i = 1; i <= N; i ++)
	{
		dp[i][1] += 1LL;
		
		for(int n = 1; n + i <= N; n ++)
		{
			for(int k = 1; k <= n; k ++)
			{
				dp[n + i][k + 1] += dp[n][k];
			}
		}
	}
	
	cout << dp[N][K] << "\n";
	
	return 0;
}
