/*
TASK:groups
LANG:C++
*/
#include <cstdio>
#include <string>
#include <vector>
#include <sstream>
#include <iostream>

#define LL long long
#define PB push_back
#define SZ size()

#define Time ((double)clock()/CLOCKS_PER_SEC)
#define pause system("pause")

#define MAXN 1024

int N,K;
const int osn=1000000000,osnc=9;
typedef std::vector<int> big;
big dp[2][MAXN];

inline void plusravno(big &a,const big &b)
{
   if (b.SZ>a.SZ) a.resize(b.SZ);
   int over=0;
   for (int i=0;i<b.SZ;i++)
    {
            over+=a[i]+b[i];
            a[i]=over%osn;
            over/=osn;
    }
   for (int i=b.SZ;i<a.SZ;i++)
    over+=a[i],a[i]=over%osn,over/=osn;
   if (over) a.PB(over);
}

std::string bigtostring(const big &a)
{
     int k=osn/10,i,j,l;
     std::ostringstream ss;
     for (i=a.size()-1; i>=0; i--)
      {
         if ((a[i]<k)&&(i<a.size()-1))
          { j=0; l=a[i]; 
            while (l>0) { l/=10; j++; } 
            if (a[i]==0) j=1;
            for (l=1; l<=osnc-j; l++) ss<<"0";
          }
         ss<<a[i];
      }
      return ss.str(); 
}


int main()
{
    scanf("%d%d",&N,&K);
    N-=K;
    
    dp[0][0].PB(1); for (int i=1;i<=N;i++) dp[0][i].PB(0);
    int at=0;
    for (int k=1;k<=K;k++)
     {
           for (int i=0;i<=N;i++)
            {
                    dp[at^1][i].clear(); dp[at^1][i].PB(0);
                    plusravno(dp[at^1][i],dp[at][i]);
                    if (i>=k)
                     plusravno(dp[at^1][i],dp[at^1][i-k]);
            }
           
           at^=1;
     }
    
    std::cout<<bigtostring(dp[at][N])<<"\n";
    return 0;
}
