#include <iostream>
using namespace std;

struct edge
{
  int s,e,n;
  edge() {};
  edge(int _s, int _e, int _n) {s=_s; e=_e; n=_n;}
};

string w;

int V[100];
char B[100];
int N,M;
unsigned long long S=0;
int cnt=0;
int sl;
edge* E;

void dfs(int i, int j)
{
  cout<<"dfs: "<<i+1<<" "<<j<<endl;
  if(j==sl) {S++; return;}
  int k = V[i];
  while(k!=-1) {
    if(B[E[k].e]==w[j]) {dfs(E[k].e, j+1);}
    k = E[k].n;
  }
}

int main()
{
  cin>>N>>M;
  E = new edge[2*M];
  for(int i=0; i<N; i++) {V[i]=-1;}
  for(int i=0; i<N; i++) {cin>>B[i];}
  for(int i=0; i<M; i++)
  {
    int s,e;
    cin>>s>>e; s--; e--;
    E[cnt]=edge(e,s,V[e]);
    V[e]=cnt++;
    if(s!=e) {
      E[cnt]=edge(s,e,V[s]);
      V[s]=cnt++;
    }
  }
  cin>>w;
  for(int i=0; i<N; i++)
  {
    int k = V[i];
    cout<<"Neighbours for "<<i<<" :\n";
    while(k!=-1) {
      cout<<E[k].e<<" ";
      k = E[k].n;
    }
    cout<<endl;
  }
  sl = w.length();
  for(int i=0; i<N; i++)
  {
    if(B[i]==w[0]) {dfs(i,1);}
  }
  cout<<S<<endl;
  return 0;
}