#include <cstdio>

typedef long long int lli;
int n, A[1024][1024], t[1024], d[1024];

struct point { int x, y; };
point a[1024], b[1024], c[1024];

inline int vp(point o, point a, point b)
{
  lli dx1=a.x-o.x, dx2=b.x-o.x,
      dy1=a.y-o.y, dy2=b.y-o.y;
  lli res=dx1*dy2-dy1*dx2;
  if(res>0) return 1; else if(res==0) return 0; else return -1;
}

inline int in(point p, int t)
{
  int sa=vp(a[t], b[t], c[t]);
  return ( sa*vp(a[t], b[t], p) > 0 ) &&
	 ( sa*vp(b[t], c[t], p) > 0 ) &&
	 ( sa*vp(c[t], a[t], p) > 0 ) ;
}

inline int in(int one, int two) { return in(a[one], two) && in(b[one], two) && in(c[one], two); }

void topsort();

int main()
{
  scanf("%d", &n);
  int i, ii, j, max=0;
  for(i=1; i<=n; i++) scanf("%d%d%d%d%d%d", &a[i].x, &a[i].y, &b[i].x, &b[i].y, &c[i].x, &c[i].y);
  for(i=1; i<=n; i++)
    for(j=1; j<=n; j++)
      A[i][j]=(i!=j?in(i, j):0);
  /*
  for(i=1; i<=n; i++)
  {
    for(j=1; j<=n; j++)
      printf("%d ", A[i][j]);
    printf("\n");
  }
  */
  topsort();
  
  //for(i=1; i<=n; i++) printf("%d ", t[i]); printf("\n");
  
  for(ii=1; ii<=n; ii++)
  {
    i=t[ii];
    d[i]=1;
    for(j=1; j<=n; j++) if(A[j][i] && d[i]<d[j]+1) d[i]=d[j]+1;
    if(max<d[i]) max=d[i];
  }
  
  //for(i=1; i<=n; i++) printf("%d ", d[i]); printf("\n");
  
  printf("%d\n", max);
  return 0;
}

int ind, vis[1024];
void dfs(int s)
{
  vis[s]=1;
  for(int i=1; i<=n; i++) if(!vis[i] && A[s][i]) dfs(i);
  t[ind--]=s;
}

void topsort()
{
  ind=n;
  for(int i=1; i<=n; i++) if(!vis[i]) dfs(i);
}
