/*
TASK: strpath
LANG: C++
*/
#include <iostream>
#include <cstring>
using namespace std;

char names[128];
char target[16];
bool g[1000][1000]={{0},{0}};
int N,M,len;
int sols = 0;

void work(int step,int pos){
	if(step == len){
		sols++;
		return;
	}
	int i=0;
	for(;i<N;i++){
		if(names[i] == target[step] && g[pos][i]){
			work(step+1,i);
		}
	}
	return;
}

int main(void){
	cin >> N >>M;
	cin >> names;
	int i,x,y;
	for(i=0;i<M;i++){
		cin >> x >> y;
		g[x-1][y-1] = g[y-1][x-1] = true;
	}
	cin >> target;
	len = strlen(target);
	for(i=0;i<N;i++){
		if(names[i] == target[0]){
			work(1,i);
		}
	}
	cout << sols << endl;
	return 0;
}
