#include <set>
#include <cstdio>
#include <iostream>

const int MAXN = 1<<5;

int n;
int a[MAXN], b[MAXN], d[MAXN];
long long c[MAXN];
std::set<long long> res;

void init (void) {
     scanf("%d", &n);
     
     for (int i = 0; i < n; ++i)
         scanf("%d", a+i);
     }

void print (void) {
     for (int i = 0; i < n; ++i) {
         std::cout<<c[i];
         switch (d[i]) {
                case 1: { printf("+"); break; }
                case 2: { printf("-"); break; }
                case 3: { printf("x"); break; }
                default: { printf("="); }
                };
         }
     }

void count (void) {
     int i, j;
     for (i = 0; i < n; ++i) { c[i] = a[i]; d[i] = b[i]; }
     //print();
     //printf("\n");
     
     for (i = 0; i < n-1; ++i) {
         for (j = i; d[j] == 3; ++j) {
             c[i] *= c[j+1];
             c[j+1] = 0;
             d[j] = 1;
             }
         i = j;
         }
     //print();
     for (int i = 0; i < n-1; ++i)
         if (d[i] == 1) c[0] += c[i+1];
            else c[0] -= c[i+1];
     
     res.insert(c[0]);
     //printf("%2d\n", c[0]);
     }

void go (int pos) {
     if (pos >= n-1) { count(); return; }
     
     b[pos] = 1; go(pos+1);
     b[pos] = 2; go(pos+1);
     b[pos] = 3; go(pos+1);
     }

void solve (void) {
     go(0);
     //printf("t=%d\n", res.size());
     //std::sort(res.begin(),res.end());
     //printf("%d\n", res.size());
     std::cout << res.size() << std::endl;
     }

int main()
{
    init();
    solve();
    
return 0;
}
