#include <cstdio>
#include <string>
#include <iostream>
#include <algorithm>

const int MAXN = 1<<10;

typedef long long i64;

std::string f[MAXN][MAXN];

std::string add (std::string s1, std::string s2) {
            if (s1.size() < s2.size()) swap(s1,s2);
            
            unsigned int pos, r = 0;
            for (pos = 0; pos < s2.size(); ++pos) {
                r += (s1[pos]-'0')+(s2[pos]-'0');
                s1[pos] = (r%10)+'0';
                r /= 10;
                }
            
            for (; r && pos < s1.size(); ++pos) {
                r += s1[pos]-'0';
                s1[pos] = (r%10)+'0';
                r /= 10;
                }
            
            while (r) {
                  s1.push_back((r%10)+'0');
                  r /= 10;
                  }
            
            return s1;
            }

void print (std::string s) {
     for (int pos = s.size()-1; pos >= 0; --pos)
         printf("%c", s[pos]);
     printf("\n");
     }

void solve (int n, int k) {
     //printf("%d %d\n", n, k);
     if (k == 1 || k == 2) {
           int p = n/k;
           f[n][k] = "";
           while (p) {
                 f[n][k].push_back((p%10)+'0');
                 p /= 10;
                 }
           //std::cout << f[n][k] << std::endl;
           return;
           }
     
     f[n][k] = "0";
     int i = 1, p = k--;
     while (true) {
           p = n-i-k*(i-1);
           if (p < k) break;
           i++;
           if (f[p][k] == "") solve(p,k);
           f[n][k+1] = add(f[n][k+1],f[p][k]);
           }
     //std::cout << f[n][k] << std::endl;
     }

int main()
{
    int n, k;
    scanf("%d%d", &n, &k);
    solve(n,k);
    print(f[n][k]);
    
return 0;
}

