#include <cstdio>
#include <vector>
#include <cstring>

const int MAXLEN = 1<<4;
const int MAXN = 1<<7;

typedef struct wtf {
        char key;
        std::vector<int> v;
        wtf() {}
        wtf(char _key, int tmp): key(_key) { v.push_back(tmp); }
        void print (void) {
             printf("key = %c\n", key);
             for (unsigned int i = 1; i < v.size(); ++i)
                 printf("%d ", v[i-1]);
             printf("%d\n", v[v.size()-1]);
             }
        } wtf;

std::vector<wtf> s;

int n, m, k;
int way[MAXLEN], ans;
char g[MAXN][MAXN];

void init (void) {
     char buf[MAXN];
     
     scanf("%d %d\n", &n, &m);
     scanf("%s", buf);
     
     unsigned int i, p, l = strlen(buf);
     for (p = 0; p < l; ++p) {
         for (i = 0; i < s.size(); ++i)
             if (s[i].key == buf[p]) { s[i].v.push_back(p+1); break; }
         if (i >= s.size()) s.push_back(wtf(buf[p],p+1));
         }
     /*
     for (i = 0; i < s.size(); ++i)
         s[i].print();
     */
     int u, v;
     for (i = 0; i < m; ++i) {
         scanf("%d %d\n", &u, &v);
         g[u][v] = g[v][u] = 1;
         }
     
     scanf("%s", buf);
     k = l = strlen(buf);
     for (p = 0; p < l; ++p)
         for (i = 0; i < s.size(); ++i)
             if (s[i].key == buf[p]) { way[p] = i; break; }
     /*
     for (i = 0; i < l; ++i) {
         printf("way[i]=%d -> ", way[i]);
         s[way[i]].print();
         }
     */
     ans = 0;
     }

void go (int x, int lvl) {
     //printf("x=%d lvl=%d\n", x, lvl);
     if (lvl == k-1) { ++ans; return; }
     for (unsigned int i = 0; i < s[way[lvl+1]].v.size(); ++i)
         if (g[x][s[way[lvl+1]].v[i]]) {
            //printf("%c\n", s[way[lvl+1]].key);
            //printf("->%d\n", s[way[lvl+1]].v[i]);
            go(s[way[lvl+1]].v[i],lvl+1);
            }
     }

void solve (void) {
     for (unsigned int i = 0; i < s[way[0]].v.size(); ++i) {
         //printf("%c\n", s[way[0]].key);
         go(s[way[0]].v[i],0);
         }
     printf("%d\n", ans);
     }

int main()
{
    init();
    solve();
    
return 0;
}

