#include <iostream>
using namespace std;

int n, k;
int g[1024], d[1024][1024], st[1024];
bool am[1024];

int closest_am( int a )
{
    int i, j, dist = INT_MAX;
    if ( am[a] == 1 )
       return 0;
    for ( i = 1; i <= n; i++ )
    {
        if ( ( am[i] == 1 ) && ( d[a][i] < dist ) )
           dist = d[a][i];
    }
    return dist;
}

int longpath( )
{
    int i, j;
    int r = 0;
    
    for ( i = 1; i <= n; i++ )
    {
        r = max( r, closest_am( i ) );
    }
    return r;
}

int genall()
{
     int i, j;
     int best;
     
     memset( am, 0, sizeof( am ) );
     for ( i = n; i > n-k; i-- )
     {
         am[i] = 1;
     }
     
     best = longpath();
     
     while ( next_permutation( &am[1], &am[n+1] ) )
     {
           j = longpath();
           if ( j < best )
           {
              best = j;
           }
     }
     return best;
}

int main()
{
    int i, j, m, x;
    int p;

    memset( d, 0, sizeof( d ) );
    memset( am, 0, sizeof( am ) );
    
    cin >> n >> k;
    if ( k >= n )
    {
         cout << "0\n";
         return 0;
    }
    for ( i = 1; i < n; i++ )
    {
        cin >> g[i];
        d[i][i+1] = g[i];
        d[i+1][i] = g[i];
    }
    
    for ( i = 2; i <= n; i++ )
    {
        d[1][i] = d[1][i-1] + d[i-1][i];
        d[i][1] = d[1][i];
    }
    
    for ( i = 2; i <= n; i++ )
    {
        for ( j = i+1; j <= n; j++ )
        {
            d[i][j] = d[1][j] - d[1][i];
            d[j][i] = d[i][j];
        }
    }

    cout << genall() << endl;
    return 0;
}   
