#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>

using namespace std;

bool pos[32][32];
char word[128], pattern[16];
int n, m, k, answer;
int B_size[128], size[128];
int B[128][128], G[128][128];

void dfs(int at, int level)
{
    if (level == k)
    {
        ++answer;
        return;
    }
    for (int i=0; i<size[at]; ++i)
        if (word[G[at][i]] == pattern[level+1])
            dfs(G[at][i], level+1);
}

void solve()
{
    k=strlen(pattern);
    --k;
    for (int i=0; i<k; ++i)
        pos[pattern[i]-'A'][pattern[i+1]-'A']=1;
    for (int i=0; i<n; ++i)
        for (int j=0; j<B_size[i]; ++j)
            if (pos[word[i]-'A'][word[B[i][j]]-'A'] == 1)
                G[i][size[i]++]=B[i][j];
    for (int i=0; i<n; ++i)
        if (word[i] == pattern[0])
            dfs(i, 0);
    printf("%d\n", answer);
}

void input()
{
    int temp1, temp2;
    
    scanf("%d%d", &n, &m);
    scanf("%s", word);
    for (int i=0; i<m; ++i)
    {
        scanf("%d%d", &temp1, &temp2);
        --temp1;
        --temp2;
        B[temp1][B_size[temp1]++]=temp2;
        if (temp1 != temp2)
            B[temp2][B_size[temp2]++]=temp1;
    }    
    scanf("%s", pattern);
}

int main()
{
    input();
    solve();
return 0;
}
