#include <iostream>
#include <string>
using namespace std;

const int MAX_N = 128;
const int MAX_W = 16;

int N, M, ans;
int a[MAX_N][MAX_N], dp[MAX_N][MAX_W];
string S, W;

void Read()
{
	memset(a, 0, sizeof(a));
	memset(dp, 0, sizeof(dp));
	ans = 0;
	
	cin >> N >> M >> S;
	
	for(int i = 0, x, y; i < M; i ++)
	{
		cin >> x >> y;
		
		x --;
		y --;
		
		a[x][y] = a[y][x] = 1;
	}
	
	cin >> W;
}

void Solve()
{
	for(int i = 0; i < N; i ++)
		if(S[i] == W[0]) dp[i][0] = 1;
	
	for(int k = 1; k < W.size(); k ++)
	{
		for(int i = 0; i < N; i ++)
		{
			if(S[i] != W[k]) continue;
			
			for(int j = 0; j < N; j ++)
			{
				if(a[i][j] == 0) continue;
				if(S[j] != W[k - 1]) continue;
				
				dp[i][k] += dp[j][k - 1];
			}
		}
	}
	
	for(int i = 0; i < N; i ++)
		ans += dp[i][W.size() - 1];
}

void Write()
{
	cout << ans << "\n";
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
