#include <iostream>
#include <cmath>
using namespace std;

long used[(1<<20)*5];
long a[1<<20];

long n, maxbr, br, i, j, x;

int checker(long k)
{
     long l = 1, r = 348500, ok = 0;
     while(1)
     {
            long m = (l+r) / 2;
            if( k < a[m] ) r = m - 1;
            if( k > a[m] ) l = m + 1;
            if( k == a[m] ) 
            {
                ok = 1; break;
            }
            if( l > r ) break;
     }
     return ok;
}    

int main ()
{
 	used[1] = 1;
 	long p = (long) sqrt(5000000);
 	for( i=2;i<=p;i++ )
 	{
	 	 if( used[i] == 0 )
	 	 for( j=i*i;j<=5000000;j+=i)
	 	 used[j] = 1;
	 }
	 long pos = 0;
	 for( i=1;i<=5000000;i++ )
	 if( used[i] == 0 ) { pos++; a[pos] = i; }
 	scanf("%d", &n);
 	for( i=1;i<=n;i++ )
 	{
	 	 br = 0;
	 	 scanf("%d", &x);
	 	 j = 1;
	 	 while (a[j]<=x)
	 	 {
		  	   if( a[j] >= (x - a[j]) && checker(x - a[j]) == 1) br ++;
		  	   j ++;
	     }
	     if( br > maxbr ) maxbr = br;
	 }
	printf("%d\n", maxbr);	  	   
 	// system("pause");
 	exit(0);
}
