#include <iostream>
using namespace std;
const int MAXN = 1000;
bool a[MAXN][MAXN];
int max_paths[MAXN], n;
struct point
{
    double x, y;
};
struct triangle
{
    point a, b, c;
};
bool same(point p1, point p2, point p3, point p4)
{
    double a = (p1.y - p2.y) / (p1.x - p2.x), b = p1.y - a * p1.x;
    if((p3.y > a * p3.x + b) && (p4.y > a * p4.x + b) || (p3.y < a * p3.x + b) && (p4.y < a * p4.x + b))
        return true;
    return false;
}
bool inner(triangle t1, triangle t2)
{
    if(!same(t1.a, t1.b, t1.c, t2.a))
        return false;
    if(!same(t1.a, t1.b, t1.c, t2.b))
        return false;
    if(!same(t1.a, t1.b, t1.c, t2.c))
        return false;
    if(!same(t1.a, t1.c, t1.b, t2.a))
        return false;
    if(!same(t1.a, t1.c, t1.b, t2.b))
        return false;
    if(!same(t1.a, t1.c, t1.b, t2.c))
        return false;
    if(!same(t1.b, t1.c, t1.a, t2.a))
        return false;
    if(!same(t1.b, t1.c, t1.a, t2.b))
        return false;
    if(!same(t1.b, t1.c, t1.a, t2.c))
        return false;
    return true;
}
int find_longest_path(int current)
{
    int i, m = 0;
    bool found = false;
    for(i = 0; i < n; i++)
        if(a[i][current])
        {
            found = true;
            max_paths[i] = find_longest_path(i);
            if(m < max_paths[i] + 1)
                m = max_paths[i] + 1;
        }
    if(found)
        max_paths[current] = m;
    else
        max_paths[current] = 1;
    return max_paths[current];
}
int main()
{
    int i, j, s, max_m = 0;
    bool b;
    triangle t[MAXN];
    cin >> n;
    for(i = 0; i < n; i++)
        cin >> t[i].a.x >> t[i].a.y >> t[i].b.x >> t[i].b.y >> t[i].c.x >> t[i].c.y;
    for(i = 0; i < n; i++)
        for(j = 0; j < n; j++)
            if(inner(t[i], t[j]))
                a[i][j] = true;
    for(i = 0; i < n; i++)
    {
        b = true;
        for(j = 0; j < n; j++)
            if(a[i][j])
                b = false;
        if(b)
        {
            find_longest_path(i);
            if(max_m < max_paths[i])
                max_m = max_paths[i];
            for(i = 0; i < n; i++)
                max_paths[i] = 0;
        }
    }
    cout << max_m << endl;
    return 0;
}
