#include<iostream>
#include<cmath>
#include<cstdio>
#include<vector>
#include<queue>
using namespace std;
struct triangle{
       int x1,y1,x2,y2,x3,y3;
       };
double naslice(double x1,double y1,double x2,double y2,double x3,double y3){
       double result=(x1-x2)*(y1+y2)+(x2-x3)*(y2+y3)+(x3-x1)*(y3+y1);
       result/=2.;
       double ep=0.1-6;
       if(fabs(result)<ep) result=0;
       return result;
       }
bool inside(double x,double y,triangle a){
     double n1=naslice(x,y,a.x1,a.y1,a.x2,a.y2);
     double n2=naslice(x,y,a.x2,a.y2,a.x3,a.y3);
     double n3=naslice(x,y,a.x3,a.y3,a.x1,a.y1);
     if(n1<0 && n2<0 && n3<0) return true;
     if(n1>0 && n2>0 && n3>0) return true;
     return false;
     }
bool inserted(triangle a,triangle b){
     if(inside(a.x1,a.y1,b) && inside(a.x2,a.y2,b) && inside(a.x3,a.y3,b)) return true;
     return false;
     }
int main(){
    int n,brp[1024]={0},len[1024],longest=0;
    vector<int> a[1024],b[1024],topol;
    triangle t[1024];
    scanf("%d",&n);
    for(int i=0;i<n;i++) scanf("%d %d %d %d %d %d",&t[i].x1,&t[i].y1,&t[i].x2,&t[i].y2,&t[i].x3,&t[i].y3);
    for(int i=0;i<n;i++)
    for(int j=i+1;j<n;j++) if(inserted(t[i],t[j])){a[i].push_back(j);b[j].push_back(i);brp[j]++;}
    else if(inserted(t[j],t[i])){a[j].push_back(i);b[i].push_back(j);brp[i]++;}
    queue<int> q;
    for(int i=0;i<n;i++) if(brp[i]==0) q.push(i);
    while(!q.empty()){
                      int u=q.front();q.pop();
                      topol.push_back(u);
                      for(int i=0;i<a[u].size();i++){brp[a[u][i]]--;if(brp[a[u][i]]==0) q.push(a[u][i]);}
                      }
    for(int i=0;i<n;i++){
            int u=topol[i];
            int f=0;
            for(int j=0;j<b[u].size();j++) if(len[b[u][j]]>f) f=len[b[u][j]];
            len[u]=f+1;
            if(len[u]>longest) longest=len[u];
            }
    printf("%d\n",longest);
    return 0;
}
