#include <cstdio>
#include <map>
#include <vector>

std::map <int, bool> used;
std::vector <int> nums;
std::vector <char> signs;
int n;

int calc() {
	std::vector <int> N = nums;
	std::vector <char> S = signs;
	
	for(int i = 0; i < S.size(); ++i) {
		if(S[i] == '*') {
			N[i] = N[i] * N[i+1];
			N.erase(N.begin() + i+1);
			S.erase(S.begin() + i--);
		}
	}
	int res = N[0];
	for(int i = 0; i < S.size(); ++i) {
		if(S[i] == '+') {
			res += N[i+1];
		} else if(S[i] == '-') {
			res -= N[i+1];
		}
	}
	
	return res;
}

void rec(int x) {
	if(x == n - 1) {
		used[calc()] = 1;
	} else {
		signs[x] = '+';
		rec(x+1);
		
		signs[x] = '-';
		rec(x+1);
		
		signs[x] = '*';
		rec(x+1);
	}
}

int main() {
	scanf("%d", &n);
	signs.resize(n-1);
	nums.resize(n);
	for(int i = 0; i < n; ++i) {
		scanf("%d", &nums[i]);
	}
	rec(0);
	
	printf("%d\n", used.size());
}
