#include <iostream>
#include <cmath>
#include <map>

int n, k;

std::map <int, std::map <int, std::map <int, long long> > > dp;

int min(int x, int y) {
	return x < y ? x : y;
}

long long F(int n, int k, int p) {
//	printf("%d %d %d\n", n, k, p);
//	system("pause");
	if(k == 1 || n == k || p == 1) {
		dp[n][k][p] = 1;
		return 1;
	} else if(n <= 0 || k <= 0 || p <= 0) {
		dp[n][k][p] = -1;
		return -1;
	}
	long long res = 0;
	for(int i = (int)ceil((double)n/k); i <= min(n-k+1, p); ++i) {
		if(!dp[n-i][k-1][i])
			F(n-i, k-1, i);
		if(dp[n-i][k-1][i] != -1)
			res += dp[n-i][k-1][i];
	}
	
//	printf("%d %d: %d\n", n, k, res);
//	system("PAUSE");
	dp[n][k][p] = res;
	
	return res;
}

int main() {
	scanf("%d%d", &n, &k);
	printf("%lld\n", F(n, k, n));
		
	return 0;
}

