#include <iostream>
#define maxN 101
#define maxM 10000001
#define Kreuzung 1

using namespace std;

int N,M;

int answer=0,depth;
string krz_abv, final;
int krz[maxN][maxN];

void init(){
  for(int i=0;i<N;i++) for(int j=0;j<N;j++) krz[i][j]=0;
}
void read (){
  cin >> N >> M;
  cin >> krz_abv;
  int a,b;
  for(int i=0;i<M;i++){
    cin >> a >> b;
    a--;b--;
    krz[a][b]=Kreuzung;
    krz[b][a]=Kreuzung;
  }
  cin >> final;
  depth = final.size();
}

void myDFS(int s, int pos){
  if (pos==depth) answer++;
  else for(int i=0;i<N;i++)
      if(krz[s][i]==Kreuzung && krz_abv[i] == final[pos]){
          myDFS(i,pos+1);
      }
}

void solve(){
  int first[maxN];
  int len=0;
  for(int i=0;i<N;i++) if(krz_abv[i]==final[0]) first[len++]=i;
  if(len!=0) for(int i=0;i<len;i++) myDFS(first[i],1);
}
void write(){ cout << answer; }
int main (){
  init();
  read();
  solve();
  write();
  return 0;
}