#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

#define MAX_N 128
#define MAX_P 16

#define f(i, n) for (int i = 0; i < n; ++i)
#define fo(i, a, b) for (int i = a; i <= b; ++i)

#define n nghbs[x][k]
#define neighbours(x) f (k, nghbs[x].size())

char map [MAX_N];
char path [MAX_P];
int N, M;
int cur = 0;
long answ = 0;
int last = 0;

vector <int> nghbs [MAX_N];

void read ()
{
  scanf ("%d %d", &N, &M);
  scanf ("%s", map);
  int a, b;
  f (i, M)
  {
    scanf ("%d %d", &a, &b);
    nghbs[a].push_back(b);
    if (a != b)
      nghbs[b].push_back(a);
  }
  scanf ("%s", path);
  last = strlen(path);
}

inline void func(int x)
{
  if (map[x-1] == path[cur])
  {
    ++cur;
    if (cur == last) ++answ;
    else neighbours(x) func(n);
    --cur;
  }
}

void solve ()
{
  fo (i, 1, N) func(i);
}

void write ()
{
  printf ("%d\n", answ);
}

int main ()
{
  read();
  solve();
  write();

  return 0;
}