/* Iordan Boev, SMG, Grupa A
 * HINT: backtrack + set
*/
# include <stdio.h>
# include <iostream>
# include <vector>
# include <queue>
# include <set>

using namespace std;

# define repi(A,B) for(int i = A; i < B; i++)
# define repj(A,B) for(int j = A; j < B; j++)
# define repk(A,B) for(int k = A; k < B; k++)
# define os(a,b,c) a.x(b.y-c.y) + b.x(c.y-a.y)+ c.x*(a.y-b.y)
# define pb push_back
# define mp make_pair
# define MAXN (1<<7)

int n,ans;
int p[MAXN];
int s[MAXN];// 1 - '+'; 2 - '-'; 3 - '*'
set <long long> used;


void read() {
    scanf("%d", &n);
    repi(0,n) {
        scanf("%d", &p[i]);
    }
}

long long calc() {
    long long rslt = p[0];

    repi(1,n) {
        if(s[i] == 1) {  
          if(s[i+1] == 3) {
                long long cur = p[i];
                int k = i+1;
                while(s[k] == 3) {
                    cur*=p[k];
                    k++;
                }
                rslt+=cur;
                i = k-1;
                continue;
            }
            rslt = rslt+p[i];
        }
        if(s[i] == 2) {
            if(s[i+1] == 3) {
                long long cur = p[i];
                int k = i+1;
                while(s[k] == 3) {
                    cur*=p[k];
                    k++;
                }
                rslt-=cur;
                i = k-1;
                continue;
            }

            rslt = rslt-p[i];
        }    
        if(s[i] == 3) {
            rslt = rslt*p[i];
        }
    }
    return rslt;

}

void solve(int p) {
    if(p == n) {
        long long c = calc();
        if(used.find(c) == used.end()) {
            ans++;
            used.insert(c);
            //printf("%lld\n", c);
        }
        return;
    }
    s[p] = 1;
    solve(p+1);
    s[p] =2;
    solve(p+1);
    s[p] = 3;
    solve(p+1);
}

int main() {
    read();
    solve(1);
    printf("%d\n", ans);
    return 0;
}
