#include <iostream>
#include <cstdio>
#include <set>
using namespace std;

#define MAXN 20

int inp[MAXN], solve[MAXN], N;

int power;

int sign[20]; //0,1,2

set <int> work;

int main()
{
 scanf("%d", &N);
 
 for (int i = 0; i < N; i++) 
  scanf("%d", &inp[i]); 
 
 power = 1;
 for (int i = 1; i < N; i++)
  power *= 3;
  
 for (int cur = 0; cur < power; cur++)
 {
  memset(sign, 0, sizeof(sign));
  int num = cur, ind = N - 2;
  while (num)
  {
   int temp = num % 3;
   sign[ind--] = temp;
   num /= 3;
  }
  memcpy(solve, inp, sizeof(int) * N);
  int tot = N;
  while (true)
  {
   bool ready = true;
   for (int i = 0; i < tot - 1; i++)
   {
    if (sign[i] == 2)
    {
     ready = false;
     solve[i] = solve[i] * solve[i + 1];
     for (int j = i; j < tot - 2; j++)
      solve[j] = solve[j + 2];
     for (int j = i; j < tot - 1; j++)
      sign[j] = sign[j + 1];
     tot--;
    }
   }
   if (ready) break;
  }
  int res = solve[0];
  for (int i = 0; i < tot - 1; i++)
  {
   if (!sign[i])
    res += solve[i + 1];
   else
    res -= solve[i + 1];
  }
  work.insert(res);
 }
 
 printf("%d\n", work.size());
 
 return 0;
}
