#include <iostream>
using namespace std;

struct Vertex
{
    int u, next;
    Vertex(int _u, int _next):u(_u), next(_next){}
    Vertex(){}
} nodes[100*100];

int table[128], cnt;
int DP[16][128], N, M;
char label[128];
char word[16];

void add(int a, int b)
{
    nodes[cnt] = Vertex(b, table[a]);
    table[a] = cnt++;
}

int main()
{
    memset(table, -1, sizeof(table));
    cin >> N >> M;
    cin >> label;
    for (int i = 0; i < M; i++)
    {
        int a, b;
        cin >> a >> b;
        add(a-1, b-1);
        if (a != b)
         add(b-1, a-1);
    }
    cin >> word;
    for (int i = 0; i < N; i++) if (label[i] == word[0]) DP[0][i] = 1;
    
    for (int k = 1; k < strlen(word); k++)
     for (int i = 0; i < N; i++) if (DP[k-1][i])
      for (int v = table[i]; v != -1; v = nodes[v].next) if (label[nodes[v].u] == word[k])
       DP[k][ nodes[v].u ] += DP[k-1][i];
           
    int ans = 0;
    for (int i = 0; i < N; i++) ans += DP[strlen(word)-1][i];
    cout << ans << endl;
    
    return 0;
}

