#include <iostream>
using namespace std;

struct point {
       int x, y;
       point () { }
       point (int _x, int _y): x(_x), y(_y) {};
};

struct triangle {
       point a[3];
} t[1000];


int N;
bool G[1000][1000];
bool used[1000];
int maxr(0);

void dfs (int i, int r) {
     maxr >?= r;
     used[i] = true;
     
     for (int k=0; k<N; k++)
         if (!used[k] && G[i][k]) dfs(k, r+1);
}

int cross (point a, point b, point c) {
    return (b.x - a.x)*(c.y - b.y) - (c.x - b.x)*(b.y - a.y);
}

bool linked (triangle x, triangle y) {
     int flag[3];
     memset (flag, 0, sizeof(flag));
     
    for (int i(0); i<3; i++)
        if ( 
             cross (x.a[0], x.a[1], y.a[i]) < 0 &&
             cross (x.a[1], x.a[2], y.a[i]) < 0 &&
             cross (x.a[0], x.a[2], y.a[i]) < 0
             ) flag[i] = -1;
        else if (
             cross (x.a[0], x.a[1], y.a[i]) > 0 &&
             cross (x.a[1], x.a[2], y.a[i]) > 0 &&
             cross (x.a[0], x.a[2], y.a[i]) > 0
           ) flag[i] = 1;
        
    if ((flag[0] == flag[1] == flag[2]) != 0) return true;
    else return false;
}

int main() {
    cin >> N;
    for (int i(0); i<N; i++) {
        int ax, bx, cx, ay, by, cy;
        cin >> ax >> ay >> bx >> by >> cx >> cy;
        t[i].a[0] = point(ax, ay);
        t[i].a[1] = point(bx, by);
        t[i].a[2] = point(cx, cy);
    }
    
    for (int i(0); i<N; i++)
        for (int j(0); j<N; j++)
            if (i!=j)
               if (linked(t[i], t[j])) 
                  G[i][j] = G[j][i] = true;
    
    dfs(0, 0);    
    cout << maxr << endl;
}


