#include <iostream>
#include <stdio.h>

#define sf scanf
#define pf printf
#define MAXN 1001

using namespace std;

int N, ans[MAXN];

struct points {
       int x, y;
};

struct triangles {
       points p[3];
} t[MAXN];

int cross(points p1, points p2, points p3) 
{
    int cp = (p2.x - p1.x)*(p3.y - p2.y) - (p3.x - p2.x)*(p2.y - p1.y);
    
    if (cp > 0)
       return 1;
    else if (cp < 0) 
       return -1;
    else 
       return 0;
}

bool check(triangles t1, triangles t2)
{
     int c = cross(t1.p[0], t1.p[1], t2.p[0]);
     if (c == 0) return false;
     
     for (int i = 0; i < 3; i++)
         for (int j = 0; j < 3; j++)
             if (cross(t1.p[i], t1.p[(i+1)%3], t2.p[j]) != c)
                return false;
     
     return true;
}
     
     
int solve()
{
     int maxx = 0;
     for (int q = 0; q < N; q++)
         for (int i = 0; i < N; i++)
                for (int j = 0; j < N; j++)
                    if (check(t[i], t[j])) {                       
                       ans[j] >?= ans[i] + 1;
                       maxx >?= ans[j];
                 }        
             
     return (maxx) ? maxx + 1 : 0;
}
                     
int main()
{
    sf("%i", &N);
    for (int i = 0; i < N; i++)
        for (int j = 0; j < 3; j++)
            sf("%i%i", &t[i].p[j].x, &t[i].p[j].y);
        
    pf("%i\n", solve());
}
