#include <iostream.h>
#include <stdio.h>
#include <Math.h>

#define sf scanf
#define pf printf

using namespace std;

struct point
{
    int x, y;
};

int cross (point a, point b, point c)
{
    return (b.x - a.x)*(c.y - b.y) - (b.y - a.y)*(c.x - b.x);
}

struct triangle
{
    point a, b, c;
    double S ()
    {
        return fabs((double)cross(a, b, c)/2);
    }
} tri[1000];

bool comp (triangle a, triangle b)
{
    return a.S() > b.S();
}

int counter, max_count, i, j, n;
bool in[1000], tried[1000][1000], k, l, m, p1, p2, p3;

void check (int index)
{
    for (j = index+1; j < n; j++)
      {
        if (tried[i][j]) continue;
        tried[i][j] = true;
        k = cross (tri[index].a, tri[index].c, tri[j].a) & 1 << 31;
        l = cross (tri[index].a, tri[index].b, tri[j].a) & 1 << 31;
        m = cross (tri[index].b, tri[index].c, tri[j].a) & 1 << 31;
        p1 = k^l^m;
        k = cross (tri[index].a, tri[index].c, tri[j].b) & 1 << 31;
        l = cross (tri[index].a, tri[index].b, tri[j].b) & 1 << 31;
        m = cross (tri[index].b, tri[index].c, tri[j].b) & 1 << 31;
        p2 = k^l^m;
        k = cross (tri[index].a, tri[index].c, tri[j].c) & 1 << 31;
        l = cross (tri[index].a, tri[index].b, tri[j].c) & 1 << 31;
        m = cross (tri[index].b, tri[index].c, tri[j].c) & 1 << 31;
        p3 = k^l^m;
        if (p1 == p2 && p1 == p3)
            counter++, in[j] = true, check(j);
      }
    max_count >?= counter;
}

int main ()
{
    sf("%i", &n);
    for (i = 0; i < n; i++)
        sf ("%i%i%i%i%i%i", &tri[i].a.x, &tri[i].a.y, &tri[i].b.x, &tri[i].b.y, &tri[i].c.x, &tri[i].c.y);
    sort (tri, tri + n, comp);
    for (int indx = 0; indx < n; indx++)
        if (!in[indx]) check(indx);
    pf ("%i\n", max_count+1);
sf ("%i", &n);
}
