#include<iostream>
#define MAXN 801
using namespace std;

typedef char longint[25];

int n, k;
longint dp[MAXN][MAXN];

void sumlong(char s1[], char s2[])
{
     int l1 = strlen(s1), l2 = strlen(s2), i, res;
     int m = l1<l2 ? l1 : l2;
     if (l2 == 0) return;
     bool ost = 0;
     for (i = 0; i < m; ++i) {
         res = s1[i] + s2[i] - 2*'0' + ost;
         if (res >= 10) {
                 res -= 10;
                 ost = 1;
         }
         else ost = 0;
         s1[i] = res + '0';
     }
     
     if (l1 > l2) {
             for (i; i < l1; ++i) {
                   res = s1[i] + ost - '0';
                   if (res >= 10) {
                           res -= 10;
                           ost = 1;
                   }
                   else ost = 0;
                   s1[i] = res + '0';
             }
     }

     if (l2 > l1) {
             for (i; i < l2; ++i) {
                   res = s2[i] + ost - '0';
                   if (res >= 10) {
                           res -= 10;
                           ost = 1;
                   }
                   else ost = 0;
                   s1[i] = res + '0';
             }
     }
     
     if (ost) s1[i++] = ost + '0';
     s1[i] = '\0';
     return;
}

void reverse(char s[]) {
     int i = 0, j = strlen(s) - 1;
     char t;
     while (i < j) {
           t = s[i];
           s[i++] = s[j];
           s[j--] = t;
     }
}

int main()
{
    int i, j;
    scanf("%d%d", &n, &k);
    
    if (n == k) {
          printf("1\n");
          return 0;
    }
    
    for (i = 0; i <= n; ++i) {
        for (j = 0; j <= n; ++j) {
            strcpy(dp[i][j], "0");
        }
    }
    
    for (i = 1; i <= n; ++i) {
        strcpy(dp[i][1], "1");
        for (j = 2; j <= n; ++j) {
            strcpy(dp[i][j], dp[i-1][j-1]);
            if (i > j) sumlong(dp[i][j], dp[i-j][j]);
        }
    }
    reverse(dp[n][k]);
    printf("%s\n", dp[n][k]);
    
    return 0;
}
