#include <iostream>
using namespace std;

struct point
{
       int x, y;
       
       point operator-( const point& a ) const
       {
             point r;
             r.x = a.x - x;
             r.y = a.y - y;
             return r;
       }
       
       int operator*( const point& b ) const
       {
           return ( x * b.y - y * b.x );
       }
};

struct triang
{
       point a, b, c;
       
       int S2() const
       {
           return abs((b-a)*(c-a));
       }
       
       bool operator<( const triang& x ) const
       {
            return ( abs( (b-a)*(c-a) ) < abs( (x.b-x.a)*(x.c-x.a) ) );
       }
};

int n;
triang t[1024];
int f[1024];

bool pin( triang a, point b )
{
     bool x, y, z;
     if ( ( a.b - a.a ) * ( b - a.a ) < 0 )
          x = 0;
     else if ( ( a.b - a.a ) * ( b - a.a ) > 0 )
          x = 1;
     else return 0;
     if ( ( a.c - a.b ) * ( b - a.b ) < 0 )
          y = 0;
     else if ( ( a.c - a.b ) * ( b - a.b ) > 0 )
          y = 1;
     else return 0;
     if ( ( a.a - a.c ) * ( b - a.c ) < 0 )
          z = 0;
     else if ( ( a.a - a.c ) * ( b - a.c ) > 0 )
          z = 1;
     else return 0;
     
     if ( ( x == y ) && ( y == z ) && ( x == z ) )
        return true;
     return false;
}

bool trin( triang a, triang b )
{
     int x = 0;
     x = pin( a, b.a ) + pin( a, b.b ) + pin( a, b.c );
     if ( x == 3 )
        return true;
     return false;
}

int main()
{
    int i, j, k;

    cin >> n;
    for ( i = 1; i <= n; i++ )
    {
        cin >> t[i].a.x >> t[i].a.y >> t[i].b.x >> t[i].b.y >> t[i].c.x >> t[i].c.y;
    }
    
    sort( &t[1], &t[n+1] );

    f[1] = 1; //f[i] - dalzh. na nai-dalga redica, s posl. el. t[i];
    for ( i = 2; i <= n; i++ )
    {
        k = 0;
        for ( j = 1; j < i; j++ )
        {
            if ( ( trin( t[i], t[j] ) ) && ( f[j] > k ) )
               k = f[j];
        }
        f[i] = k + 1;
    }
    
    k = 0;
    for ( i = 1; i <= n; i++ )
    {
        if ( f[i] > k )
           k = f[i];
    }
    cout << k << endl;
    
    return 0;
}
